<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® Personal Use Edition, 7.8 of 2011年3月30日 on 2011年12月25日 at 06:26:50</time-stamp>


<component-created>
<name>KSU-Template</name> <type>package</type>
</component-created><!-- Package KSU-Template* -->


<component-property>
<name>KSU-Template</name> <type>package</type>
<property>comment</property> <value>'Copyright 2008-2011 KSU (Kyoto Sangyo University). All Right Reserved.
'</value>
</component-property>

<class>
<name>ColorHSB</name>
<environment>KSU</environment>
<super>UI.ApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>hueGauge saturationGauge brightnessGauge </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>KSU-Template</category>
<attributes>
<package>KSU-Template</package>
</attributes>
</class>

<comment>
<class-id>KSU.ColorHSB</class-id>
<body>Copyright 2008-2011 KSU (Kyoto Sangyo University). All Right Reserved.
</body>
</comment>

<class>
<name>ColorHSBView</name>
<environment>KSU</environment>
<super>UI.View</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>aspectSelector </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>KSU-Template</package>
</attributes>
</class>

<comment>
<class-id>KSU.ColorHSBView</class-id>
<body>Copyright 2008-2011 KSU (Kyoto Sangyo University). All Right Reserved.
</body>
</comment>

<class>
<name>ColorHSBController</name>
<environment>KSU</environment>
<super>UI.Controller</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category></category>
<attributes>
<package>KSU-Template</package>
</attributes>
</class>

<comment>
<class-id>KSU.ColorHSBController</class-id>
<body>Copyright 2008-2011 KSU (Kyoto Sangyo University). All Right Reserved.
</body>
</comment>

<methods>
<class-id>KSU.ColorHSBController</class-id> <category>events</category>

<body package="KSU-Template" selector="exitEvent:">exitEvent: event

	super exitEvent: event.
	Cursor normal show.
	^nil</body>

<body package="KSU-Template" selector="mouseMovedEvent:">mouseMovedEvent: event

	self viewHasCursor ifTrue: [Cursor crossHair show] ifFalse: [Cursor normal show].
	^nil</body>

<body package="KSU-Template" selector="redButtonPressedEvent:">redButtonPressedEvent: event

	| aspectArea previousPoint currentPoint normalizedValue |
	aspectArea := self view aspectArea.
	previousPoint := nil.
	[self sensor redButtonPressed] whileTrue: 
			[currentPoint := self sensor cursorPoint.
			currentPoint = previousPoint
				ifFalse: 
					[| endingTime |
					endingTime := Time microsecondClock + 250000.
					normalizedValue := (currentPoint x - aspectArea left) / (aspectArea right - aspectArea left).
					normalizedValue := 0 max: (normalizedValue min: 1).
					(self model perform: (self view aspectSelector , 'Gauge') asSymbol) value: normalizedValue.
					(Delay untilMicroseconds: endingTime) wait.
					previousPoint := currentPoint].
			Processor yield].
	^nil</body>

<body package="KSU-Template" selector="enterEvent:">enterEvent: event

	super enterEvent: event.
	Cursor crossHair show.
	^nil</body>
</methods>


<methods>
<class-id>KSU.ColorHSBView</class-id> <category>accessing</category>

<body package="KSU-Template" selector="aspectArea">aspectArea

	^self bounds insetBy: self defaultInset</body>

<body package="KSU-Template" selector="aspectSelector:">aspectSelector: aSymbol

	aspectSelector := aSymbol</body>

<body package="KSU-Template" selector="aspectSelector">aspectSelector

	^aspectSelector</body>
</methods>

<methods>
<class-id>KSU.ColorHSBView</class-id> <category>defaults</category>

<body package="KSU-Template" selector="defaultInset">defaultInset

	^6 @ 6</body>
</methods>

<methods>
<class-id>KSU.ColorHSBView</class-id> <category>displaying</category>

<body package="KSU-Template" selector="displayAspectAreaOn:">displayAspectAreaOn: graphicsContext

	| pixmap gc area symbol left right top bottom |
	pixmap := Pixmap extent: self aspectArea extent.
	gc := pixmap graphicsContext.
	area := pixmap bounds.
	symbol := self aspectSelector.
	left := area left.
	right := area right.
	top := area top.
	bottom := area bottom.
	left to: right - 1
		do: 
			[:x |
			| value color box |
			value := (x - left) / (right - left).
			color := self model color.
			symbol = #hue
				ifTrue: 
					[color := ColorValue
								hue: value
								saturation: 1 yourself
								brightness: 1 yourself].
			symbol = #saturation
				ifTrue: 
					[color := ColorValue
								hue: color hue
								saturation: value
								brightness: 1 yourself].
			symbol = #brightness
				ifTrue: 
					[color := ColorValue
								hue: color hue
								saturation: color saturation
								brightness: value].
			box := x @ top corner: (x + 1) @ bottom.
			gc
				paint: color;
				displayRectangle: box].
	pixmap
		displayOn: graphicsContext at: self aspectArea origin;
		close</body>

<body package="KSU-Template" selector="displayMarksOn:">displayMarksOn: graphicsContext

	| symbol color value area point box points |
	symbol := self aspectSelector.
	color := self model color.
	value := color perform: symbol.
	area := self aspectArea.
	point := ((value * area width + area left) @ area top) rounded.
	box := 0 @ 0 corner: self defaultInset.
	box := box align: box bottomCenter with: point.
	points := Array
				with: box bottomCenter
				with: box topLeft
				with: box topRight
				with: box bottomCenter.
	graphicsContext
		paint: ColorValue black;
		displayPolygon: points.
	box := box insetBy: 1.
	points := Array
				with: box bottomCenter
				with: box topLeft
				with: box topRight
				with: box bottomCenter.
	graphicsContext
		paint: ColorValue white;
		displayPolygon: points.
	point := ((value * area width + area left) @ area bottom) rounded.
	box := 0 @ 0 corner: self defaultInset.
	box := box align: box topCenter with: point.
	points := Array
				with: box topCenter
				with: box bottomLeft
				with: box bottomRight
				with: box topCenter.
	graphicsContext
		paint: ColorValue black;
		displayPolygon: points.
	box := box insetBy: 1.
	points := Array
				with: box topCenter
				with: box bottomLeft
				with: box bottomRight
				with: box topCenter.
	graphicsContext
		paint: ColorValue white;
		displayPolygon: points</body>

<body package="KSU-Template" selector="displayAspectAreasOutsideOn:">displayAspectAreasOutsideOn: graphicsContext

	graphicsContext paint: self backgroundColor.
	(self bounds areasOutside: self aspectArea) do: [:aRectangle | graphicsContext displayRectangle: aRectangle]</body>

<body package="KSU-Template" selector="displayOn:">displayOn: graphicsContext

	self model ifNil: [^nil].
	self
		displayAspectAreasOutsideOn: graphicsContext;
		displayAspectAreaOn: graphicsContext;
		displayMarksOn: graphicsContext</body>
</methods>

<methods>
<class-id>KSU.ColorHSBView</class-id> <category>initialize-release</category>

<body package="KSU-Template" selector="initialize">initialize

	super initialize.
	aspectSelector := nil.
	^self</body>
</methods>

<methods>
<class-id>KSU.ColorHSBView</class-id> <category>updating</category>

<body package="KSU-Template" selector="update:">update: aspectSymbol

	self invalidateNow</body>
</methods>

<methods>
<class-id>KSU.ColorHSBView</class-id> <category>controller accessing</category>

<body package="KSU-Template" selector="defaultControllerClass">defaultControllerClass

	^KSU.ColorHSBController</body>
</methods>


<methods>
<class-id>KSU.ColorHSB class</class-id> <category>interface specs</category>

<body package="KSU-Template" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: '色相・彩度・明度' 
			#min: #(#{Core.Point} 512 160 ) 
			#max: #(#{Core.Point} 512 160 ) 
			#bounds: #(#{Graphics.Rectangle} 1024 640 1536 800 ) 
			#flags: 4 
			#menu: #menuBar ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 24 17 ) 
					#name: #hueLabel 
					#colors: 
					#(#{UI.LookPreferences} 
						#setBackgroundColor: #(#{Graphics.ColorValue} #pink ) ) 
					#label: '色相 :' ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 24 49 ) 
					#name: #saturationLabel 
					#colors: 
					#(#{UI.LookPreferences} 
						#setBackgroundColor: #(#{Graphics.ColorValue} 6143 8191 6143 ) ) 
					#label: '彩度：' ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 24 81 ) 
					#name: #brightnessLabel 
					#colors: 
					#(#{UI.LookPreferences} 
						#setBackgroundColor: #(#{Graphics.ColorValue} 6143 6143 8191 ) ) 
					#label: '明度：' ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.Rectangle} 72 17 488 40 ) 
					#name: #hueView 
					#component: #hueView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.Rectangle} 72 49 488 72 ) 
					#name: #saturationView 
					#component: #saturationView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.Rectangle} 72 81 488 104 ) 
					#name: #brightnessView 
					#component: #brightnessView ) ) ) )</body>
</methods>

<methods>
<class-id>KSU.ColorHSB class</class-id> <category>examples</category>

<body package="KSU-Template" selector="example1">example1
	"KSU.ColorHSB example1."

	| anApplication |
	anApplication := KSU.ColorHSB new.
	anApplication open.
	^anApplication</body>
</methods>

<methods>
<class-id>KSU.ColorHSB class</class-id> <category>resources</category>

<body package="KSU-Template" selector="menuBar">menuBar
	"Tools.MenuEditor new openOnClass: self andSelector: #menuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 'ファイル' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: '終了' 
							#value: #closeRequest ) ) #(1 ) nil ) ) ) #(1 ) nil ) decodeAsLiteralArray</body>
</methods>


<methods>
<class-id>KSU.ColorHSB</class-id> <category>aspects</category>

<body package="KSU-Template" selector="brightnessGauge">brightnessGauge

	brightnessGauge
		ifNil: 
			[brightnessGauge := 0.5 asValue.
			brightnessGauge compute: [:aValue | self updateColorBrightness: aValue]].
	^brightnessGauge</body>

<body package="KSU-Template" selector="saturationGauge">saturationGauge

	saturationGauge
		ifNil: 
			[saturationGauge := 0.5 asValue.
			saturationGauge compute: [:aValue | self updateColorSaturation: aValue]].
	^saturationGauge</body>

<body package="KSU-Template" selector="hueGauge">hueGauge

	hueGauge
		ifNil: 
			[hueGauge := 0.5 asValue.
			hueGauge compute: [:aValue | self updateColorHue: aValue]].
	^hueGauge</body>
</methods>

<methods>
<class-id>KSU.ColorHSB</class-id> <category>accessing</category>

<body package="KSU-Template" selector="color">color

	| aColor |
	aColor := ColorValue
				hue: (0 max: (self hueGauge value min: 1))
				saturation: (0 max: (self saturationGauge value min: 1))
				brightness: (0 max: (self brightnessGauge value min: 1)).
	^aColor</body>
</methods>

<methods>
<class-id>KSU.ColorHSB</class-id> <category>private</category>

<body package="KSU-Template" selector="updateColor">updateColor

	self builder
		ifNotNil: 
			[:aBuilder |
			aBuilder window
				ifNotNil: 
					[:aWindow |
					aWindow
						background: self color;
						display]]</body>

<body package="KSU-Template" selector="updateColorSaturation:">updateColorSaturation: aValue

	InputState default altDown
		ifTrue: 
			[self hueGauge value = aValue ifFalse: [self hueGauge value: aValue].
			self brightnessGauge value = aValue ifFalse: [self brightnessGauge value: aValue]].
	self updateColor</body>

<body package="KSU-Template" selector="updateColorBrightness:">updateColorBrightness: aValue

	InputState default altDown
		ifTrue: 
			[self hueGauge value = aValue ifFalse: [self hueGauge value: aValue].
			self saturationGauge value = aValue ifFalse: [self saturationGauge value: aValue]].
	self updateColor</body>

<body package="KSU-Template" selector="updateColorHue:">updateColorHue: aValue

	InputState default altDown
		ifTrue: 
			[self saturationGauge value = aValue ifFalse: [self saturationGauge value: aValue].
			self brightnessGauge value = aValue ifFalse: [self brightnessGauge value: aValue]].
	self updateColor</body>
</methods>

<methods>
<class-id>KSU.ColorHSB</class-id> <category>interface opening</category>

<body package="KSU-Template" selector="hueView">hueView

	| aView |
	aView := ColorHSBView model: self.
	aView aspectSelector: #hue.
	^aView</body>

<body package="KSU-Template" selector="postOpenWith:">postOpenWith: aBuilder

	super postOpenWith: aBuilder.
	self updateColor</body>

<body package="KSU-Template" selector="brightnessView">brightnessView

	| aView |
	aView := ColorHSBView model: self.
	aView aspectSelector: #brightness.
	^aView</body>

<body package="KSU-Template" selector="saturationView">saturationView

	| aView |
	aView := ColorHSBView model: self.
	aView aspectSelector: #saturation.
	^aView</body>
</methods>

<methods>
<class-id>KSU.ColorHSB</class-id> <category>initialize-release</category>

<body package="KSU-Template" selector="initialize">initialize

	super initialize.
	hueGauge := nil.
	saturationGauge := nil.
	brightnessGauge := nil.
	^self</body>
</methods>



</st-source>
